//Test della classe IntBST

public class BSTOfPeople
{
	public static void main (String[] args)
	{
		BST people = new BST();
		inizializza (people);
		try
		{
			stampaPreorder(people);
		}
		catch (EmptyTreeException e)
		{
			System.out.println ("Albero vuoto.");
		}
		System.exit(1);
	}

	public static void inizializza (BST t)
	{
		boolean flag = false;
		ConsoleReader console = new ConsoleReader ();
		String scelta = "", nome = "";
		int anni = 0;
		while (!flag)
		{
			System.out.print ("Vuoi inserire una persona nel BST? (SI, NO): ");
			scelta = console.readLine();
			if (scelta.equalsIgnoreCase("SI"))
			{
				System.out.print ("Inserisci il nome della persona: ");
				nome = console.readLine();
				boolean check = false;
				while (!check)
				{
					try
					{
						System.out.print ("Inserisci l'eta' della persona: ");
						anni = console.readInt();
						check = true;
					}
					catch (NumberFormatException e)
					{
					}
				}
				t.insert(new Person (nome, anni));
			}
			else if (scelta.equalsIgnoreCase("NO"))
			{
				flag = true;
			}
		}
	}

	public static void stampaPreorder (BST t)
	{
		if (t.isEmpty(t.getRoot()))
			throw new EmptyTreeException();
		else stampaPreorder (t.getRoot());
	}

	private static void stampaPreorder (BSTNode p)
	{
		if (p != null)
		{
			System.out.println (p.getKey());
			stampaPreorder (p.getLeft());
			stampaPreorder (p.getRight());
		}
	}
}