/* Esercizi parte 1, n 4:
	Scrivere un metodo per convertire un numero in base 10 nel corrispondente in base 2.
*/

public class ConvertiBase
{
	public static String converti (int num)
	{
		int r; //variabile contenente il resto
		String output = "";

		while (num > 0)
		{
			r = num % 2; //estraggo il resto della div. per 2
			num = num / 2; //calcolo il ris. della div. per 2
			output = Integer.toString (r) + output;
		}
		return output;
	}

	public static String converti (int num, int base)
	{
		if (base <= 1 || base > 16)
			throw new IllegalArgumentException ();
	
	String []simboli = 
	{"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B", "C", "D", "E", "F"};

   int r;
	String output = "";
	while (num > 0)
	{
		r = num % base;
		num = num / base;
		output = simboli [r] + output;
	}
	return output;
}

	//main:
	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader ();
		System.out.print ("Inserisci il numero in base 10 da convertire: ");
		int n = console.readInt();

		System.out.print ("Inserisci la base in cui convertire "+n+" : ");
		int b = console.readInt();

		System.out.println ("Il numero convertito in base "+b+" e': "+converti(n,b));
		System.exit(1);
	}
}