//Programma che legge un file di testo e lo ricopia in un altro

import java.io.*;

public class CopyAFile {
	public static void main (String[] args)
	{
		int n;
		boolean esci = false;

		while (!esci)
		{
			ConsoleReader console = new ConsoleReader ();
			System.out.print ("Inserisci il nome del file da copiare");
			System.out.println (" (\"FINE\" per uscire):");
			String fileInput = console.readLine();

			if (fileInput.compareToIgnoreCase("FINE") == 0)
			{
				esci = true; 	//esci dal ciclo
			}

			else {
				System.out.print ("Inserisci il nome del file di destinazione:");
				String fileOutput = console.readLine();
				try
				{
					FileReader fileIn = new FileReader (fileInput); //per leggere il primo file
					FileWriter fileOut = new FileWriter (fileOutput); //per scivere il secondo file
				
					for (n = fileIn.read(); n != -1; n = fileIn.read())
					{
						fileOut.write((char)n);
					}

					fileIn.close();
					fileOut.close();
					esci = true;
				}
				catch (IOException e)
				{
					System.out.println (e);
					System.exit(1);
				}
			}
		}
	}
}