/* Esercizi parte 1, esercizio n 2:
	Trasferire gli elementi della pila S1 nella pila S2 in 
	modo che gli elementi di S2 risultino avere lo stesso 
	ordinamento che evavano in S1 (usare una terza pila di supporto).
*/

public class EsercizioA2
{
	static void trasferisci (IntStackArray b, IntStackArray a)
	{ a.push (b.pop()); }
	
	static void inizializza (IntStackArray a, int dim)
	{ for (int i = 0; i < dim ; i++)
		a.push ((int)(10 * Math.random () + 1));
	}

	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader ();
		System.out.print ("Quanti elementi avra' la tua pila? ");
		int n = console.readInt();

		IntStackArray sorg = new IntStackArray (n);
 	   IntStackArray temp = new IntStackArray (n);
		IntStackArray dest = new IntStackArray (n);

		//inizializzazione casuale degli elementi della prima pila
		inizializza (sorg, n);

		System.out.println (sorg.topElem());

		//trasferimento:
		int i;
		for (i = 0; i < n ; i++)
			trasferisci (sorg, temp);
		for (i = 0; i < n ; i++)
			trasferisci (temp, dest);

		System.out.println (dest.topElem());

		System.exit(1);
	}
}
