/* Esercizi parte 1, n 7:
	Scrivere un metodo per verificare se due liste 
	semplicemente concatenate hanno lo stesso contenuto.
*/

public class EsercizioA7
{
	public static boolean confronta (IntListPlus a, IntListPlus b)
	{
		int i, j;
		
		//primo confronto: se entrambe le liste non sono istanziate lancia l'eccezione
		if ((a == null) || (b == null))
			throw new ListNotFoundException();

		//ricordarsi che se una lista termina prima dell'altra, allora le due liste sono diverse
		do
		{
			try
			{
				i = a.getNextElem();
			}
			catch (OutOfListException e)
			{
				//se la lista a finisce, controllo se finisce anche la lista b
				try
				{
					b.getNextElem();
					//se il metodo non genera eccezione viene eseguita l'istruzione successiva
					return false; //le liste sono diverse
				}
				catch (OutOfListException exc)
				{
					return true;
				}
			}
			try //questo blocco viene eseguito SOLO se la prima lista non  terminata
			{
				j = b.getNextElem();
			}
			catch (OutOfListException e)
			{
				//la lista b  finita, quindi le due liste sono diverse
				return false;
			}
		}
		//condizione di terminazione:
		while (i == j); //in caso contrario le liste sono diverse
		return false;
	}
}

