/* Esercizi, parte 1, n 8:
	Concatenare una lista semplicemente concatenata 
	ad un'altra lista semplicemente concatenata.
*/

public class EsercizioA8
{
	public static IntListPlus concatena (IntListPlus a, IntListPlus b)
	{
		if (a.isEmpty() || b.isEmpty())
			throw new EmptyListException ();

		IntListPlus output = new IntListPlus ();
		a.rewind();
		b.rewind();
		boolean controllo = false;

		while (!controllo)
		{
			try
			{
				output.insertTail (a.getNextElem());
			}
			catch (OutOfListException e)
			{
				try
				{
					output.insertTail(b.getNextElem());
				}
				catch (OutOfListException exc)
				{
					controllo = true;
				}
			}
		}
		return output;
	}

	//main:
	public static void main (String[] args)
	{
		IntListPlus a = new IntListPlus ();
		IntListPlus b = new IntListPlus ();
		
		int i = 0;
		int random = (int)(100 * Math.random() + 1);
		for ( ; i < random; i++)
			a.insertOrdered ((int)(100 * Math.random () + 1));

		random = (int)(100 * Math.random() + 1);
		for (i = 0; i < random; i++)
			b.insertOrdered ((int)(100 * Math.random () + 1));

		IntListPlus out = concatena (a, b);
		
		boolean controllo = false;
		while (!controllo)
		{
			try
			{
				System.out.println (out.getNextElem());
			}
			catch (OutOfListException e)
			{
				controllo = true;
			}
		}

		System.exit(1);
	}
}
