/*
	Esercizio, parte 2, n 10:
	Scrivere un metodo che, dato un albero 
	binario, restituisca il valore del livello 
	col numero maggiore di nodi.
*/

public class EsercizioB10
{
	public static int getMaxNodeLevel(IntBST a)
	{
		if (a.isEmpty(a.getRoot()))
			throw new EmptyTreeException();
		if (a.getRoot().getLeft() == null && a.getRoot().getRight() == null)
			return 0;
		QueueList queue = new QueueList();
		QueueList supp = new QueueList();
		IntBSTNode p = a.getRoot();
		int max = 1, cont = 0, level = 1, levelMax = 0;
		supp.enQueue (p);
		while (!supp.isEmpty())
		{
			p = (IntBSTNode) supp.deQueue();
			if (p.getLeft() != null)
				queue.enQueue (p.getLeft());
			if (p.getRight() != null)
				queue.enQueue (p.getRight());
			if (supp.isEmpty())
			{
				while (!queue.isEmpty())
				{
					supp.enQueue (queue.deQueue());
					cont++;
				}
				if (cont >= max)
				{
					max = cont;
					levelMax = level;
				}
				cont = 0;
				level++;
			}
		}
		return levelMax;
	}
	
	//main:
	public static void main (String[] args)
	{
		IntBST tree = new IntBST ();
		BinaryTrees.inizialize (tree);
		System.out.println ("Il livello con numero max di nodi e' "+getMaxNodeLevel(tree));
		System.exit(1);
	}
}