//Classe con metodi per il calcolo dell'unione fra due insiemi rappresentati da due liste semplici

public class IntersezioneListe
{
	//liste ordinate:
	public static IntListPlus getUnionOrd (IntListPlus a, IntListPlus b)
	{
		if (a.isEmpty() && b.isEmpty())
			return new IntListPlus();
		else if (a.isEmpty())
			return b;
		else if (b.isEmpty())
			return a;
		else
		{
			a.rewind();
			b.rewind();
			IntListPlus union = new IntListPlus();
			boolean flag = false;
			while (!flag)
			{
				try
				{
					union.insertOrdered (a.getNextElem());
				}
				catch (OutOfListException e)
				{
					flag = true;
				}
			}
			flag = false;
			int el;
			while (!flag)
			{
				try
				{
					el = b.getNextElem();
					if (a.searchOrd (el) == null)
						union.insertOrdered (el);
				}
				catch (OutOfListException e)
				{
					flag = true;
				}
			}
			return union;
		}
	}

	//liste non ordinate:
	public static IntListPlus getUnion (IntListPlus a, IntListPlus b)
	{
		if (a.isEmpty() && b.isEmpty())
			return new IntListPlus();
		else if (a.isEmpty())
			return b;
		else if (b.isEmpty())
			return a;
		else
		{
			a.rewind();
			b.rewind();
			IntListPlus union = new IntListPlus();
			boolean flag = false;
			while (!flag)
			{
				try
				{
					union.insertOrdered (a.getNextElem());
				}
				catch (OutOfListException e)
				{
					flag = true;
				}
			}
			flag = false;
			int el;
			while (!flag)
			{
				try
				{
					el = b.getNextElem();
					if (a.search(el) == null)
						union.insertOrdered (el);
				}
				catch (OutOfListException e)
				{
					flag = true;
				}
			}
			return union;
		}
	}

	//main:
	public static void main (String[] args)
	{
		IntListPlus lista1 = new IntListPlus(), lista2 = new IntListPlus();
		System.out.println ("Prima lista:");
		Lists.inizialize (lista1);
		System.out.println ("Seconda lista:");
		Lists.inizialize (lista2);
		Lists.printList (getUnion (lista1, lista2));
		System.exit(1);
	}
}