//Inversione di una lista mediante una sola scansione

public class InversioneLista
{
	public static ListPlus inverti (ListPlus a)
	{
		if (a.isEmpty())
			throw new EmptyListException();
		a.rewind();

		ListPlus output = new ListPlus ();
		boolean controllo = false;

		while (!controllo)
		{
			try
			{
				output.insertHead (a.getNextElem ());
			}
			catch (OutOfListException e)
			{
				controllo = true;
			}
		}
		return output;
	}

	//main:
	public static void main (String[] args)
	{
		Person io = new Person ("Fabio", 18);
		Person miaSorella = new Person ("Sabrina", 13);
		Person unoStupido = new Person ("Pinco", 99);
		ListPlus people = new ListPlus ();
		people.insertTail (io);
		people.insertTail (miaSorella);
		people.insertTail (unoStupido);
		ListPlus a = inverti (people);
		System.out.println (a.deleteHead());
		System.exit(1);
	}
}