/*
	Seconda prova in itinere 2001/02:
	Scrivere un metodo Java che, dato un albero binario 
	di ricerca, calcoli la lunghezza del cammino caratteristico 
	del nodo contenente il successore della chiave della radice.
*/

//Classe con metodo statico:
public class Itinere2_0102
{
	public static int getCammCarSuccRoot (IntBST t)
	{
		if (t.isEmpty(t.getRoot()))
			throw new EmptyTreeException ();
		IntBSTNode p = t.getRoot();
		if (p.getRight() == null)
			return -1;
		else
		{
			int cont = 1;
			p = p.getRight();
			while (p.getLeft() != null)
			{
				p = p.getLeft();
				cont++;
			}
			return cont;
		}
	}

	//main:
	public static void main (String[] args)
	{
		IntBST tree = new IntBST();
		BinaryTrees.inizialize (tree);
		System.out.println ("Cammino caratteristico del succ. della radice: "+getCammCarSuccRoot(tree));
		System.exit(1);
	}
}
