//Classe Vettori con metodi per l'inizializzazione e la stampa di arrays

public class Vettori
{
	private static ConsoleReader console = new ConsoleReader();

	//inizializzazione:
	public static void inizializza (int[] data)
	{
		int i = 0;
		for ( ; i < data.length; i++)
		{
			System.out.print ("Inserisci un intero: ");
			data[i] = console.readInt();
		}
		System.out.println();
	}

	public static void inizializza (char[] data)
	{
		int i = 0;
		for ( ; i < data.length; i++)
		{
			System.out.print ("Inserisci un carattere: ");
			try
			{
				data[i] = console.readChar();
			}
			catch (Exception e)
			{
				System.out.println ("Errore, riprova.");
				i--;
			}
		}
		System.out.println();
	}

	public static void inizializza (double[] data)
	{
		int i = 0;
		for ( ; i < data.length; i++)
		{
			System.out.print ("Inserisci un numero in virgola mobile: ");
			data[i] = console.readDouble();
		}
		System.out.println();
	}

	public static void inizializza (String[] data)
	{
		int i = 0;
		for ( ; i < data.length; i++)
		{
			System.out.print ("Inserisci una stringa alfanumerica: ");
			data[i] = console.readLine();
		}
		System.out.println();
	}

	//metodi per la visualizzazione:
	public static void visualizza (int[] data)
	{
		int i = 0;
		for ( ; i < data.length; i++)
			System.out.print ("["+i+"] = "+data[i]+"\n");
		System.out.println();
	}

	public static void visualizza (char[] data)
	{
		int i = 0;
		for ( ; i < data.length; i++)
			System.out.print ("["+i+"] = "+data[i]+"\n");
		System.out.println();
	}

	public static void visualizza (double[] data)
	{
		int i = 0;
		for ( ; i < data.length; i++)
			System.out.print ("["+i+"] = "+data[i]+"\n");
		System.out.println();
	}

	public static void visualizza (Object[] data)
	{
		int i = 0;
		for ( ; i < data.length; i++)
			System.out.print ("["+i+"] = "+data[i]+"\n");
		System.out.println();
	}

	//main:
	public static void main (String[] args)
	{
		String[] a = new String[5];
		inizializza (a);
		visualizza (a);
		System.exit(1);
	}
}