/****************************************************************
*******************classe IntCircularListPlus********************
****************************************************************/
public class IntCircularListPlus extends IntCircularList
{
	private boolean controllo;
	private IntNode aux, succ;
	
	//Costruttore:
	public IntCircularListPlus ()
	{
		super();
		controllo = false;
	}

	//rewind:
	public void rewind()
	{
		aux = head;
		succ = null;
		controllo = true;
	}

	//getNextElem:
	public int getNextElem ()
	{
		if (controllo == false)
			rewind();
		IntNode tmp = aux;
		if (succ == head.getNext() && aux == head)
			throw new OutOfListException ();
		succ = aux.getNext().getNext();
		aux = aux.getNext();
		return tmp.getInfo();
	}
}

/****************************************************************
********************classe CircularListPlus**********************
****************************************************************/
class CircularListPlus extends CircularList
{
	private boolean controllo;
	private Node aux, succ;
	
	//Costruttore:
	public CircularListPlus ()
	{
		super();
		controllo = false;
	}

	//rewind:
	public void rewind()
	{
		aux = head;
		succ = null;
		controllo = true;
	}

	//getNextElem:
	public Object getNextElem ()
	{
		if (controllo == false)
			rewind();
		Node tmp = aux;
		if (succ == head.getNext() && aux == head)
			throw new OutOfListException ();
		succ = aux.getNext().getNext();
		aux = aux.getNext();
		return tmp.getInfo();
	}
}

/****************************************************************
******************classe IntCircularListDllPlus******************
****************************************************************/
class IntCircularListDllPlus extends IntCircularListDll
{
	private boolean controllo;
	private IntNodeDll aux, succ;
	
	//Costruttore:
	public IntCircularListDllPlus ()
	{
		super();
		controllo = false;
	}

	//rewind:
	public void rewind()
	{
		aux = head;
		succ = null;
		controllo = true;
	}

	//getNextElem:
	public int getNextElem ()
	{
		if (controllo == false)
			rewind();
		IntNodeDll tmp = aux;
		if (succ == head.getNext() && aux == head)
			throw new OutOfListException ();
		succ = aux.getNext().getNext();
		aux = aux.getNext();
		return tmp.getInfo();
	}
}

/****************************************************************
*******************classe CircularListDllPlus********************
****************************************************************/
class CircularListDllPlus extends CircularListDll
{
	private boolean controllo;
	private NodeDll aux, succ;
	
	//Costruttore:
	public CircularListDllPlus ()
	{
		super();
		controllo = false;
	}

	//rewind:
	public void rewind()
	{
		aux = head;
		succ = null;
		controllo = true;
	}

	//getNextElem:
	public Object getNextElem ()
	{
		if (controllo == false)
			rewind();
		NodeDll tmp = aux;
		if (succ == head.getNext() && aux == head)
			throw new OutOfListException ();
		succ = aux.getNext().getNext();
		aux = aux.getNext();
		return tmp.getInfo();
	}
}

