//classe IntListaPlus che implementa 2 nuovi metodi per la classe IntLista

public class IntListPlus extends IntList
{
	private IntNode aux;
	private boolean controllo;

	//Costruttore
	public IntListPlus ()
	{
		super ();
		controllo = false;
	}

	//metodo rewind:
	public void rewind ()
	{
		aux = head;
		controllo = true;
	}

	//metodo getNextElem:
	public int getNextElem ()
	{
		if (controllo == false)
			rewind();
		IntNode tmp = aux;
		if (aux == null)
			throw new OutOfListException();
		else
		{
			aux = aux.getNext();
			return tmp.getInfo();
		}
	}
}

