//Implementazione di una Pila di interi mediante liste semplicemente concatenate

import java.util.EmptyStackException;

public class IntStackList
{
	private IntListPlus elem;

	//Costruttore (inizializza una Pila vuota)
	public IntStackList ()
	{
		elem = new IntListPlus();
	}

	public boolean isEmpty ()
	{ return (elem.isEmpty()); }

	public void clear ()
	{ elem = new IntListPlus(); }

	public void push (int val)
	{ elem.insertHead (val); }

	public int pop ()
	{
		if (isEmpty())
			throw new EmptyStackException();
		else
		{
			int o;
			elem.rewind ();
			o = elem.getNextElem ();
			elem.deleteHead ();
			return o;
		}
	}

	public int topElem ()
	{
		if (isEmpty())
			throw new EmptyStackException();
		else
		{
			elem.rewind ();
			return elem.getNextElem();
		}
	}
}