/*
	Esame del 18/06/2002, 1A:
	Scrivere un metodo Java che, data una stringa 
	alfanumerica contenente anche parentesi tonde, 
	quadre e graffe, decida se tutte le parentesi 
	sono correttamente accoppiate e se sono poste 
	nel giusto ordine.
*/

public class Delimiters
{
	public static boolean checkDelimiters (String s)
	{
		if (s == null || s.length() == 0)
			throw new NullPointerException();
		int i = 0;
		StackList supp = new StackList();
		while (i < s.length())
		{
			if (s.charAt(i) == '(' || s.charAt(i) == '[' || s.charAt(i) == '{')
				supp.push (new Character (s.charAt(i)));
			else if (s.charAt(i) == ')' || s.charAt(i) == ']' || s.charAt(i) == '}')
			{
				if (supp.isEmpty() 
					|| (s.charAt(i) == ')' && ((Character)(supp.pop())).charValue() != '(')
					|| (s.charAt(i) == ']' && ((Character)(supp.pop())).charValue() != '[')
					|| (s.charAt(i) == '}' && ((Character)(supp.pop())).charValue() != '{'))
					return false;
			}
			i++;
		}
		if (supp.isEmpty())
			return true;
		else return false;
	}
	

	//main:
	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader();
		System.out.print ("Digita una frase qualsiasi: ");
		String frase = console.readLine ();
		try
		{
			if (checkDelimiters (frase) == true)
				System.out.println ("C'e' una perfetta corrispondenza fra le parentesi");
			else System.out.println ("Riscontrati degli errori!");
		}
		catch (NullPointerException e)
		{
			System.out.println ("Non hai digitato nessuna frase!");
		}
		System.exit(1);
	}
}
