/*
	Esame del 28-01-2003:
	Scrivere un metodo statico Java TreeList che, 
	dati in input un albero binario A ed un numero 
	intero K, restituisca in una lista i campi info 
	dei nodi dell'albero A di livello K.
*/

public class Esame28_01_03
{
	public static IntListPlus getLevel (IntBST t, int k)
	{
		if (t.isEmpty(t.getRoot()))
			throw new EmptyTreeException ();
		IntListPlus output = new IntListPlus ();
		QueueList queue = new QueueList(), supp = new QueueList();
		IntBSTNode p = t.getRoot();
		int level = 0;
		supp.enQueue (p);
		while (!queue.isEmpty() || level < k)
		{
			p = (IntBSTNode) supp.deQueue();
			if (p.getLeft() != null)
				queue.enQueue (p.getLeft());
			if (p.getRight() != null)
				queue.enQueue (p.getRight());
			if (supp.isEmpty())
			{
				level++;
				while (!queue.isEmpty())
					supp.enQueue (queue.deQueue());
			}
		}
		while (!supp.isEmpty())
			output.insertTail (((IntBSTNode)supp.deQueue()).getKey());
		return output;
	}

	//metodo che ritorna un intero dato in input da tastiera
	public static int input ()
	{
		ConsoleReader console = new ConsoleReader ();
		System.out.print ("Inserisci un numero intero: ");
		return console.readInt();
	}

	//main:
	public static void main (String[] args)
	{
		IntBST tree = new IntBST ();
		BinaryTrees.inizialize (tree);
		int num = input();
		Lists.printList (getLevel(tree, num));
		System.exit(1);
	}
}
