/* Esercizi, parte 1, n 10:
	Fondere due liste semplicemente concatenate ed ordinate di 
	interi in una lista semplicemente concatenata ordinata.
*/

public class EsercizioA10
{
	public static IntListPlus unisci (IntListPlus a, IntListPlus b)
	{
		if (a.isEmpty() || b.isEmpty())
			throw new EmptyListException ();

		IntListPlus output = new IntListPlus ();
		boolean controllo = false;

		while (!controllo)
		{
			try
			{
				output.insertOrdered (a.getNextElem ());
			}
			catch (OutOfListException e)
			{
				try
				{
					output.insertOrdered (b.getNextElem ());
				}
				catch (OutOfListException exc)
				{
					controllo = true;
				}
			}
		}

		return output;
	}

	//main:
	public static void main (String[] args)
	{
		IntListPlus lista1 = new IntListPlus ();
		IntListPlus lista2 = new IntListPlus ();

		int i = 0;
		for ( ; i < 10; i++)
			lista1.insertOrdered ((int)(10 * Math.random () + 1));

		for (i = 0; i < 5; i++)
			lista2.insertOrdered ((int)(10 * Math.random () + 1));

		IntListPlus lista3 = unisci(lista1, lista2);
		boolean flag = false;
		while (!flag)
		{
			try
			{
				System.out.println (lista3.getNextElem());
			}
			catch (OutOfListException e)
			{
				flag = true;
			}
		}
		
		System.exit(1);
	}
}
