/* Esercizi parte 1, n 5:
	Dato un carattere, eseguire ricorsivamente:
	a) il controllo della sua appartenenza ad una stringa;
	b) il conteggio di tutte le sue occorrenze in una stringa;
	c) le rimozione di tutte le sue occorrenze in una stringa.
*/

//soluzione NON ricorsiva:

public class EsercizioA5
{
	//main:
	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader();
		System.out.print ("Digita una parola: ");
		String s = console.readLine();
		System.out.print ("Digita un carattere: ");
		String str = console.readLine();
		char c = str.charAt (0);
		System.out.println ("check returns: "+check(s,c));
		System.out.println ("recursiveCheck returns: "+recursiveCheck(s,c));
		System.out.println ("occ returns: "+occ(s,c));
		System.out.println ("recursiveOcc returns: "+recursiveOcc(s,c));
		System.out.println ("removeOcc returns: "+removeOcc(s,c));
		System.out.println ("recursiveRemoveOcc returns: "+recursiveRemoveOcc(s,c));
		System.exit(1);
	}

	//metodo a:
	public static boolean check (String s, char c)
	{
		for (int i = 0; i < s.length(); i++)
		{
			if (s.charAt(i) == c)
				return true;
		}
		return false;
	}

	//metodo a (ricorsivo):
	public static boolean recursiveCheck (String s, char c)
	{
		if (c == s.charAt(0))
			return true;
		else if (s.length() > 1)
			return recursiveCheck (s.substring (1, s.length()), c);
		else return false;
	}

	//metodo b:
	public static int occ (String s, char c)
	{
		int k = 0;
		for (int i = 0; i < s.length(); i++)
			if (s.charAt(i) == c)
				k++;
		return k;
	}

	//metodo b (ricorsivo):
	public static int recursiveOcc (String s, char c)
	{
		int k = 0;
		if (s.length() == 0)
			return k;
		else 
		{  if (s.charAt(0) == c)
				k++;
			return k + recursiveOcc (s.substring (1, s.length()), c);
		}
	}

	//metodo c:
	public static String removeOcc (String s, char c)
	{
		String tmp = "";
		for (int i = 0; i < s.length(); i++)
			if (s.charAt(i) != c)
				tmp += s.charAt(i);
		return tmp;
	}

	//metodo c (ricorsivo):
	public static String recursiveRemoveOcc (String s, char c)
	{
		String output = "";
		if (s.length() == 0)
			return output;
		else
		{
			if (s.charAt(0) != c)
				output += s.charAt(0);
			return output += recursiveRemoveOcc (s.substring(1, s.length()), c);
		}
	}
}
