/*
	Esercizio, parte 2, n 5:
	Scrivere un metodo che crei una lista contenente 
	tutti in nodi di un albero ordinati per livello
*/

public class EsercizioB5
{
	public static IntListPlus getListLevel (IntBST t)
	{
		return getListLevel (t.getRoot());
	}

	private static IntListPlus getListLevel (IntBSTNode p)
	{
		IntListPlus list = new IntListPlus();
		QueueList queue = new QueueList ();
		if (p != null)
		{
			queue.enQueue (p);
			while (!queue.isEmpty())
			{
				p = (IntBSTNode)queue.deQueue();
				list.insertTail (p.getKey());
				if (p.getLeft() != null)
					queue.enQueue (p.getLeft());
				if (p.getRight() != null)
					queue.enQueue (p.getRight());
			}
		}
		return list;
	}
	
	//main:
	public static void main (String[] args)
	{
		IntBST tree = new IntBST ();
		BinaryTrees.inizialize (tree);
		Lists.printList (getListLevel (tree));
		System.exit(1);
	}
}
