//Soluzioni ricorsiva del probema delle torri di Hanoi

public class Hanoi
{
	public static void recursiveHanoi (int sorg, int temp, int dest, int dim)
	{
		if (dim > 0)
		{
			recursiveHanoi (sorg, dest, temp, dim - 1);
			System.out.println ("Spostamento da "+sorg+" a "+dest);
			recursiveHanoi (temp, sorg, dest, dim - 1);
		}
	}

	public static void main (String[] args)
	{
		ConsoleReader console = new ConsoleReader ();
		System.out.print ("Quanti dischi vuoi spostare? ");
		int n = console.readInt();
		try
		{
			recursiveHanoi (1, 2, 3, n);
		}
		catch (IllegalArgumentException e)
		{
			System.out.println (e);
		}
		System.exit(1);
	}
}
