/*
	Esercizio parte 2, n 3:
	Scrivere un metodo statico che, dati due insiemi 
	numerici rappresentati mediante alberi binari di 
	ricerca (senza ripetizioni), crei l'albero rappresentante 
	l'intersezione dei due insiemi. Utilizzare un metodo 
	di visita dell'albero costruito, onde verificare la 
	correttezza dell'albero.
*/

public class IntersezioneBST
{
	public static IntBST getIntersection (IntBST a, IntBST b)
	{
		IntBST intersection = new IntBST();
		if (a.isEmpty(a.getRoot()) || b.isEmpty(a.getRoot()))
			return intersection;
		IntBSTNode n = a.getRoot();
		IntQueueList supp = new IntQueueList();
		insertQueuePreorder (supp, n);
		int i = 0, el;
		for ( ; i < b.getNumNodi (b.getRoot()); i++)
		{
			el = supp.deQueue();
			if (el == b.search(b.getRoot(),el).getKey())
				intersection.insert(el);
			supp.enQueue (el);
		}
		return intersection;
	}

	private static void insertQueuePreorder (IntQueueList queue, IntBSTNode node)
	{
		if (node != null)
		{
			queue.enQueue (node.getKey());
			insertQueuePreorder (queue, node.getLeft());
			insertQueuePreorder (queue, node.getRight());
		}
	}

	public static void printBSTPreorder (IntBST a)
	{
		printBSTPreorder (a.getRoot());
	}

	private static void printBSTPreorder (IntBSTNode node)
	{
		if (node != null)
		{
			System.out.print (node.getKey()+ " ");
			printBSTPreorder (node.getLeft());
			printBSTPreorder (node.getRight());
		}
	}

	//main:
	public static void main (String[] args)
	{
		IntBST albero1 = new IntBST ();
		IntBST albero2 = new IntBST ();
		printBSTPreorder (getIntersection (albero1, albero2));
		System.exit(1);
	}
}

