//Classe con metodi per l'inizializzazione di una lista

public class Lists
{
	/********************************************************
	***********LISTA SEMPLICEMENTE LINKATA DI INTERI*********
	********************************************************/
	public static void inizialize (IntListPlus l)
	{
		ConsoleReader console = new ConsoleReader();
		boolean flag = false;
		String scelta = "", tipo = "";
		while (!flag)
		{
			System.out.print ("Vuoi inserire un elemento? (SI, NO): ");
			scelta = console.readLine();
			if (scelta.equalsIgnoreCase("SI"))
			{
				boolean check = false;
				while (!check)
				{
					System.out.print ("Che tipo d'inserimento: (TESTA, CODA, ORDINATO): ");
					tipo = console.readLine();
					if (tipo.equalsIgnoreCase("TESTA") || 
					tipo.equalsIgnoreCase("CODA") || tipo.equalsIgnoreCase("ORDINATO"))
						check = true;
				}
				System.out.print ("Digita un numero intero: ");
				if (tipo.equalsIgnoreCase("TESTA"))
					l.insertHead (console.readInt());
				else if (tipo.equalsIgnoreCase("CODA"))
					l.insertTail (console.readInt());
				else if (tipo.equalsIgnoreCase("ORDINATO"))
					l.insertTail (console.readInt());
				else continue;
			}
			else if (scelta.equalsIgnoreCase("NO"))
			{
				flag = true;
			}
		}
	}

	public static void printList (IntListPlus l)
	{
		l.rewind();
		boolean flag = false;
		while (!flag)
		{
			try
			{
				System.out.print (l.getNextElem()+ " ");
			}
			catch (OutOfListException e)
			{
				System.out.println();
				flag = true;
			}
		}
	}

	/********************************************************
	************LISTA DOPPIAMENTE LINKATA DI INTERI**********
	********************************************************/
	public static void inizialize (IntListDllPlus l)
	{
		ConsoleReader console = new ConsoleReader();
		boolean flag = false;
		String scelta = "", tipo = "";
		while (!flag)
		{
			System.out.print ("Vuoi inserire un elemento? (SI, NO): ");
			scelta = console.readLine();
			if (scelta.equalsIgnoreCase("SI"))
			{
				boolean check = false;
				while (!check)
				{
					System.out.print ("Che tipo d'inserimento: (TESTA, CODA, ORDINATO): ");
					tipo = console.readLine();
					if (tipo.equalsIgnoreCase("TESTA") || 
					tipo.equalsIgnoreCase("CODA") || tipo.equalsIgnoreCase("ORDINATO"))
						check = true;
				}
				System.out.print ("Digita un numero intero: ");
				if (tipo.equalsIgnoreCase("TESTA"))
					l.insertHead (console.readInt());
				else if (tipo.equalsIgnoreCase("CODA"))
					l.insertTail (console.readInt());
				else if (tipo.equalsIgnoreCase("ORDINATO"))
					l.insertTail (console.readInt());
				else continue;
			}
			else if (scelta.equalsIgnoreCase("NO"))
			{
				flag = true;
			}
		}
	}

	public static void printList (IntListDllPlus l)
	{
		l.rewind();
		boolean flag = false;
		while (!flag)
		{
			try
			{
				System.out.print (l.getNextElem()+ " ");
			}
			catch (OutOfListException e)
			{
				System.out.println();
				flag = true;
			}
		}
	}

	/********************************************************
	*****LISTA SEMPLICEMENTE LINKATA CIRCOLARE DI INTERI*****
	********************************************************/
	public static void inizialize (IntCircularListPlus l)
	{
		ConsoleReader console = new ConsoleReader();
		boolean flag = false;
		String scelta = "", tipo = "";
		while (!flag)
		{
			System.out.print ("Vuoi inserire un elemento? (SI, NO): ");
			scelta = console.readLine();
			if (scelta.equalsIgnoreCase("SI"))
			{
				boolean check = false;
				while (!check)
				{
					System.out.print ("Che tipo d'inserimento: (TESTA, CODA, ORDINATO): ");
					tipo = console.readLine();
					if (tipo.equalsIgnoreCase("TESTA") || 
					tipo.equalsIgnoreCase("CODA") || tipo.equalsIgnoreCase("ORDINATO"))
						check = true;
				}
				System.out.print ("Digita un numero intero: ");
				if (tipo.equalsIgnoreCase("TESTA"))
					l.insertHead (console.readInt());
				else if (tipo.equalsIgnoreCase("CODA"))
					l.insertTail (console.readInt());
				else if (tipo.equalsIgnoreCase("ORDINATO"))
					l.insertTail (console.readInt());
				else continue;
			}
			else if (scelta.equalsIgnoreCase("NO"))
			{
				flag = true;
			}
		}
	}

	public static void printList (IntCircularListPlus l)
	{
		l.rewind();
		boolean flag = false;
		while (!flag)
		{
			try
			{
				System.out.print (l.getNextElem()+ " ");
			}
			catch (OutOfListException e)
			{
				System.out.println();
				flag = true;
			}
		}
	}

	/********************************************************
	*****LISTA DOPPIAMENTE LINKATA CIRCOLARE DI INTERI*******
	********************************************************/
	public static void inizialize (IntCircularListDllPlus l)
	{
		ConsoleReader console = new ConsoleReader();
		boolean flag = false;
		String scelta = "", tipo = "";
		while (!flag)
		{
			System.out.print ("Vuoi inserire un elemento? (SI, NO): ");
			scelta = console.readLine();
			if (scelta.equalsIgnoreCase("SI"))
			{
				boolean check = false;
				while (!check)
				{
					System.out.print ("Che tipo d'inserimento: (TESTA, CODA, ORDINATO): ");
					tipo = console.readLine();
					if (tipo.equalsIgnoreCase("TESTA") || 
					tipo.equalsIgnoreCase("CODA") || tipo.equalsIgnoreCase("ORDINATO"))
						check = true;
				}
				System.out.print ("Digita un numero intero: ");
				if (tipo.equalsIgnoreCase("TESTA"))
					l.insertHead (console.readInt());
				else if (tipo.equalsIgnoreCase("CODA"))
					l.insertTail (console.readInt());
				else if (tipo.equalsIgnoreCase("ORDINATO"))
					l.insertTail (console.readInt());
				else continue;
			}
			else if (scelta.equalsIgnoreCase("NO"))
			{
				flag = true;
			}
		}
	}

	public static void printList (IntCircularListDllPlus l)
	{
		l.rewind();
		boolean flag = false;
		while (!flag)
		{
			try
			{
				System.out.print (l.getNextElem()+ " ");
			}
			catch (OutOfListException e)
			{
				System.out.println();
				flag = true;
			}
		}
	}
}