//Programma che legge un file di testo selezionato in input

import java.io.*;

public class ReadAFile {
	public static void main (String[] args)
	{
		int n;
		boolean esci = false;  //per determinare l'uscita dal ciclo

		while (!esci) {	//cio fin quando esci  false
			//istanza di ConsoleReader per leggere in input il nome del file
			ConsoleReader console = new ConsoleReader ();
			System.out.print ("Inserisci il nome del file che vuoi leggere");
			System.out.println (" (\"FINE\" per uscire):");
			//prendo in input il nome del file
			String nomeFile = console.readLine();

			//controlle se l'utente ha digitato FINE
			if (nomeFile.compareToIgnoreCase("FINE") == 0)	   //l'utente ha digitato FINE o fine
			{
				esci = true;
			}

			//in caso contrario procedo con la lettura del file
			else
			{
				//occorre gestire un'eventuale eccezione (FileNotFound o I/O)
				try
				{
					FileReader file = new FileReader (nomeFile);	//istanza di FileReader
					//lettura del file
					for (n = file.read(); n != -1; n = file.read())
					{
						System.out.print ((char)n);	//la lettura restituisce un byte per volta
					}
					//terminata la lettura chiudi lo stream
					file.close();
					esci = true;	//per uscire dal ciclo
				}
				//blocchi catch per catturare eventuali eccezioni
				catch (IOException e)
				{
					System.out.println (e);
					System.exit(1);
				}
				/*catch (FileNotFoundException exc)
				{
					System.out.println (exc);
				}*/
			}
		}
	}
}