//Classe con metodi che calcolano l'uniione fra liste semplicemente concatenate ordinate e non

public class UnioneListe
{
	//liste non ordinate
	public static IntListPlus getUnion (IntListPlus a, IntListPlus b)
	{
		if (a.isEmpty() || b.isEmpty())
			throw new EmptyListException();
		a.rewind();
		b.rewind();
		boolean cnt1 = false, cnt2 = false;
		int el1 = 0, el2;
		IntListPlus union = new IntListPlus ();
		while (!cnt1)
		{
			try
			{
				union.insertTail (a.getNextElem());
			}
			catch (OutOfListException e)
			{
				cnt1 = true;
			}
		}
		cnt1 = false;
		while (!cnt1)
		{
			try
			{
				el1 = b.getNextElem();
			}
			catch (OutOfListException e)
			{
				cnt1 = cnt2 = true;
			}
			while (!cnt2)
			{
				try
				{
					el2 = union.getNextElem();
					if (el1 == el2)
						cnt2 = true;
				}
				catch (OutOfListException exc)
				{
					union.insertTail (el1);
					cnt2 = true;
				}
			}
			cnt2 = false;
			union.rewind();
		}
		return union; 
	}

	//main:
	public static void main (String[] args)
	{
		IntListPlus lista1 = new IntListPlus();
		IntListPlus lista2 = new IntListPlus();
		int i = 0, random = (int)(10*Math.random()+1);
		for ( ; i <= random; i++)
			lista1.insertTail ((int)(20*Math.random()+1));
		random = (int)(10*Math.random()+1);
		for (i = 0; i <= random; i++)
			lista2.insertTail ((int)(20*Math.random()+1));
		boolean controllo = false;
		System.out.println ("Prima lista:");
		while (!controllo)
		{
			try
			{ 
				System.out.print (lista1.getNextElem()+ " ");
			}
			catch (OutOfListException e)
			{
				System.out.println ();
				controllo = true;
			}
		}
		System.out.println ("Seconda lista:");
		controllo = false;
		while (!controllo)
		{
			try
			{
				System.out.print (lista2.getNextElem()+ " ");
			}
			catch (OutOfListException e)
			{
				System.out.println ();
				controllo = true;
			}
		}
		IntListPlus unione = getUnion (lista1, lista2);
		controllo = false;
		System.out.println ("Unione:");
		while (!controllo)
		{
			try
			{
				System.out.print (unione.getNextElem()+" ");
			}
			catch (OutOfListException e)
			{
				System.out.println ();
				controllo = true;
			}
		}
		System.exit(1);
	}
}
