//Classe IntNodo per la struttura dati: lista semplicemente concatenata di INTERI

public class IntNode
{
	//variabili d'istanza:
	private int info;  //il campo info  solo un numero di tipo int
	private IntNode next; //campo "link" al nodo successivo della lista

	//Costruttore con 1 argomento:
	public IntNode (int val)
	{
		//richiamo il costruttore con 2 argomenti:
		this (val, null);
	}

	//Costruttore con 2 argomenti:
	public IntNode (int val, IntNode n)
	{
		info = val;
		next = n;
	}

	//metodi di accesso/modifica alle variabili d'istanza private
	public int getInfo ()				{ return info; }
	
	public void setInfo (int val)
   {
		info = val;
	}

	public IntNode getNext ()				{ return next; }
	
	public void setNext (IntNode n)
	{
		next = n;
	}
}
