//Implementazione mediante lista concatenata di una coda di interi

public class IntQueueList
{
	private IntListPlus elem;

	//Costruttore:
	public IntQueueList ()
	{
		elem = new IntListPlus();
	}

	//metodo che verifica se la lista  vuota
	public boolean isEmpty()
	{ return (elem.isEmpty()); }

	//metodo che cancella la struttura dati
	public void clear ()
	{ elem = new IntListPlus(); }

	//metodo che restituisce il primo elemento della coda
	public int firstElem ()
	{
		if (isEmpty())
			throw new EmptyQueueException();
		else
		{
			elem.rewind ();
			return elem.getNextElem();
		}
	}
	//metodo per l'inserimento di un elemento nella coda
	public void enQueue (int val)
	{
		elem.insertTail (val);
	}

	//metodo per l'estrazione di un elemento dalla coda
	public int deQueue ()
	{
		if (isEmpty())
			throw new EmptyQueueException();
		else
		{
			int o;
			elem.rewind ();
			o = elem.getNextElem ();
			elem.deleteHead ();
			return o;
		}
	}
}