//classe ListaPlus che implementa 2 nuovi metodi per la classe IntList

public class ListPlus extends List
{
	private Node aux;
	private boolean controllo;

	//Costruttore
	public ListPlus ()
	{
		super ();
		controllo = false;
	}

	//metodo rewind:
	public void rewind ()
	{
		aux = head;
		controllo = true;
	}

	//metodo getNextElem:
	public Object getNextElem ()
	{
		if (controllo == false)
			rewind();
		Node tmp = aux;
		if (aux == null)
			throw new OutOfListException();
		else
		{
			aux = aux.getNext();
			return tmp.getInfo();
		}
	}

	public static void printList (ListPlus l)
	{
		if (l.isEmpty())
			System.out.println ("Lista vuota");
		else
		{
			l.rewind();
			boolean flag = false;
			while (!flag)
			{
				try
				{
					System.out.print (l.getNextElem()+" ");
				}
				catch (OutOfListException e)
				{
					flag = true;
				}
			}
		}
	}
}