//Implementazione mediante lista concatenata di una coda di oggetti generici

public class QueueList
{
	private ListPlus elem;

	//Costruttore:
	public QueueList ()
	{
		elem = new ListPlus();
	}

	//metodo che verifica se la lista  vuota
	public boolean isEmpty()
	{ return (elem.isEmpty()); }

	//metodo che cancella la struttura dati
	public void clear ()
	{ elem = new ListPlus(); }

	//metodo che restituisce il primo elemento della coda
	public Object firstElem ()
	{
		if (isEmpty())
			throw new EmptyQueueException();
		else
		{
			elem.rewind ();
			return elem.getNextElem();
		}
	}
	//metodo per l'inserimento di un elemento nella coda
	public void enQueue (Object obj)
	{
		elem.insertTail (obj);
	}

	//metodo per l'estrazione di un elemento dalla coda
	public Object deQueue ()
	{
		if (isEmpty())
			throw new EmptyQueueException();
		else
		{
			Object o = null;
			elem.rewind ();
			o = elem.getNextElem ();
			elem.deleteHead ();
			return o;
		}
	}
}
