//Implementazione di una Pila di oggetti generici mediante liste semplicemente concatenate

import java.util.EmptyStackException;

public class StackList
{
	private ListPlus elem;

	//Costruttore (inizializza una Pila vuota)
	public StackList ()
	{
		elem = new ListPlus();
	}

	public boolean isEmpty ()
	{ return (elem.isEmpty()); }

	public void clear ()
	{ elem = new ListPlus(); }

	public void push (Object obj)
	{ elem.insertHead (obj); }

	public Object pop ()
	{
		if (isEmpty())
			throw new EmptyStackException();
		else
		{
			Object o = null;
			elem.rewind ();
			o = elem.getNextElem ();
			elem.deleteHead ();
			return o;
		}
	}

	public Object topElem ()
	{
		if (isEmpty())
			throw new EmptyStackException();
		else
		{
			elem.rewind ();
			return elem.getNextElem();
		}
	}
}